/*
 * @Description: file content
 * @Author: your name
 * @version: 
 * @Date: 2024-06-17 14:51:25
 * @LastEditors: your name
 * @LastEditTime: 2024-06-18 10:15:19
 */
import { defHttp } from '/@/utils/http/axios';
import { GetUserInfoModel, GetUserInfoModel2 } from './model/userModel';

import { ErrorMessageMode } from '#/axios';
import { ApiAction } from '../model/baseModel';
import { AccountInfo } from '../tigerapi/model/systemModel';

enum Api {
  Login = '/login/login',
  Logout = '/login/logout',
  GetUserInfo = '/Login/GetLoginInfo',
  SwitchOrgCode = '/Login/SwitchOrgCode',
  GetPermCode = '/getPermCode',
  TestRetry = '/testRetry',
}

/**
 * @description: user login api
 */
export function loginApi(params: AccountInfo, mode: ErrorMessageMode = 'modal') {
  return defHttp.post<ApiAction<GetUserInfoModel2>>(
    {
      url: Api.Login,
      params,
    },
    {
      errorMessageMode: mode,
      isTransformResponse: false,
    },
  );
}

/**
 * @description: getUserInfo
 */
export function getUserInfo() {
  return defHttp.get<GetUserInfoModel>({ url: Api.GetUserInfo }, { errorMessageMode: 'none' });
}

export function getTgUserInfo() {
  return defHttp.get<GetUserInfoModel2>(
    {
      url: Api.GetUserInfo,
    },
    { errorMessageMode: 'none', isTransformResponse: false },
  );
}
export function SwitchOrgCode(token:string,org:string,fty:string) {
  return defHttp.get<GetUserInfoModel2>(
    {
      url: Api.SwitchOrgCode,params:{token,org, fty}
    },
    { errorMessageMode: 'none', isTransformResponse: false },
  );
}

export function getPermCode() {
  return defHttp.get<string[]>({ url: Api.GetPermCode });
}

export function doLogout(params: ApiAction<string>) {
  return defHttp.post<ApiAction<string>>({ url: Api.Logout, params });
}


export function testRetry() {
  return defHttp.get(
    { url: Api.TestRetry },
    {
      retryRequest: {
        isOpenRetry: true,
        count: 5,
        waitTime: 1000,
      },
    },
  );
}
